/* PM Project 2018. 
 *
 * Title:
 *	Feed me like one of your French girls!
 * Description:
 *	Helmet that helps you drink & eat automatically while relaxing.
 * Author:
 *	Popescu Ana-Cosmina
 *	331CC
 */
#include <avr/io.h>

#include <util/delay.h>

#define PLATE_LEFT 230
#define PLATE_RIGHT 630
#define DOOR_CLOSED 10
#define DOOR_OPENED 60
#define STRAW_DOWN 150
#define STRAW_UP 500

void wait(int n_delays)
{
	uint8_t i;
	for(i = 0; i < n_delays; ++i)
		_delay_loop_2(0);
}

void pour_food()
{
	OCR0A = DOOR_OPENED;
	wait(30);
	OCR0A = DOOR_CLOSED;
}

void move_plate_left()
{
	while (OCR1A > PLATE_LEFT) {
		_delay_loop_2(0);
		OCR1A -= 2;
	}
}

void move_plate_right()
{
	while (OCR1A < PLATE_RIGHT) {
		_delay_loop_2(0);
		OCR1A += 2;
	}		
}

void eat()
{
	pour_food();
	wait(50);
	move_plate_left();
        wait(200);
	move_plate_right();
}

void drink()
{
	OCR1B = STRAW_UP;
	wait(200);
	OCR1B = STRAW_DOWN;
}

int main(void)
{
   /* Configure TIMER1:
	- type: FPWM 
	- TOP: ICR1			=> WGM13..0 = 1110
	- OVF: TOP
	- prescaler: 64			=> CS12..0 = 011
	- clear on comp, set on bottom.	=> COM1A1..0 = COM1B1..0 = 10
    */
   TCCR1A|=(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11);  
   TCCR1B|=(1<<WGM13)|(1<<WGM12)|(1<<CS11)|(1<<CS10);

   ICR1=4999;  //fPWM=50Hz (Period = 20ms Standard).

   DDRD|=(1<<PD4)|(1<<PD5);   //PWM Pins as Out: OC1B & OC1A

   /* Configure TIMER0:
	- type: FPWM 
	- TOP: 0xFF			=> WGM02..0 = 011
	- OVF: MAX
	- prescaler: 1024			=> CS02..0 = 101
	- clear on comp, set on bottom.	=> COM1A1..0 = COM1B1..0 = 10
    */
   TCCR0A|=(1<<COM0A1)|(1<<COM0B1)|(1<<WGM01)|(1<<WGM00);  
   TCCR0B|=(1<<CS02)|(1<<CS00);

   DDRB|=(1<<PB3);   //PWM Pins as Out: OC0A

   OCR1A = PLATE_RIGHT;
   OCR0A = DOOR_CLOSED;
   OCR1B = STRAW_DOWN;

   while(1)
   {
	wait(50);
	eat();
	wait(50);
	drink();
   }
   return 0;
}

